/**************************************************************************************************

Parsing.h -- (C) Niklas Een, Niklas Srensson, 2004
Extended by Antonin Lejsek 2005

Parses input, builds and register constrs

**************************************************************************************************/

#ifndef Parsing_h
#define Parsing_h

#include "SolverTypes.h"
#include "Constraints.h"
#include "Solver.h"


class Constr_reg {
	vec<Constr*> constrs;	
	void registerConstrToSAT(Solver& S,vec<int>& ints,const char*type);
	void readVector(char*& in, Solver& S, vec<int>& ints);
	bool parse_DIMACS_main(char* in, Solver& S);
public:
	void registerConstr(Constr*  c);
    bool parse_DIMACS(FILE* in, Solver& S);	// Inserts problem into solver. Returns FALSE upon immediate conflict.
	~Constr_reg(){for(int i=0;i<constrs.size();++i)delete constrs[i];constrs.clear(false);};
};




//=================================================================================================





#endif

